Jappix Protocol Support
=======================

Here are listed the XMPP Protocol Extensions that Jappix supports, as well as their implementation version.


# XMPP Core

 * RFC-6120: Extensible Messaging and Presence Protocol (XMPP): Core
 * RFC-6121: Extensible Messaging and Presence Protocol (XMPP): Instant Messaging and Presence
 * RFC-6122: Extensible Messaging and Presence Protocol (XMPP): Address Format


# XMPP Extensions (Standardized)

 * XEP-0004: Data Forms *v2.9*
 * XEP-0012: Last Activity *v2.0*
 * XEP-0016: Privacy Lists *v1.6*
 * XEP-0030: Service Discovery *v2.4*
 * XEP-0045: Multi-User Chat *v1.25*
 * XEP-0049: Private XML Storage *v1.2*
 * XEP-0050: Ad-Hoc Commands *v1.2*
 * XEP-0054: vcard-temp *v1.2*
 * XEP-0055: Jabber Search *v1.3*
 * XEP-0060: Publish-Subscribe *v1.13*
 * XEP-0066: Out of Band Data *v1.5*
 * XEP-0071: XHTML-IM *v1.5*
 * XEP-0072: SOAP Over XMPP *v1.0*
 * XEP-0077: In-Band Registration *v2.4*
 * XEP-0080: User Location *v1.7*
 * XEP-0084: User Avatar *v1.1*
 * XEP-0085: Chat State Notifications *v2.1*
 * XEP-0092: Software Version *v1.1*
 * XEP-0107: User Mood *v1.2*
 * XEP-0108: User Activity *v1.3*
 * XEP-0115: Entity Capabilities *v1.5*
 * XEP-0118: User Tune *v1.2*
 * XEP-0124: Bidirectional-streams Over Synchronous HTTP (BOSH) *v1.10*
 * XEP-0144: Roster Item Exchange *v1.0*
 * XEP-0152: Reachability Addresses *v1.0*
 * XEP-0166: Jingle *v1.1*
 * XEP-0167: Jingle RTP Sessions *v1.1*
 * XEP-0172: User Nickname *v1.1*
 * XEP-0176: Jingle ICE-UDP Transport Method *v1.0*
 * XEP-0177: Jingle Raw UDP Transport Method *v1.1*
 * XEP-0184: Message Delivery Receipts *v1.2*
 * XEP-0199: XMPP Ping *v2.0*
 * XEP-0202: Entity Time *v2.0*
 * XEP-0203: Delayed Delivery *v2.0*
 * XEP-0224: Attention *v1.0*
 * XEP-0215: External Service Discovery *v0.5*
 * XEP-0249: Direct MUC Invitations *v1.2*
 * XEP-0262: Use of ZRTP in Jingle RTP Sessions *v1.0*
 * XEP-0266: Codecs for Jingle Audio *v1.0*
 * XEP-0269: Jingle Early Media *v0.1*
 * XEP-0277: Microblogging over XMPP *v0.6*
 * XEP-0278: Jingle Relay Nodes *v0.2*
 * XEP-0280: Message Carbons *v0.9*
 * XEP-0292: vCard4 Over XMPP *v0.10*
 * XEP-0293: Jingle RTP Feedback Negotiation *v0.1*
 * XEP-0294: Jingle RTP Header Extensions Negotiation *v0.1*
 * XEP-0299: Codecs for Jingle Video *v0.1*
 * XEP-0308: Last Message Correction *v1.0*
 * XEP-0319: Last User Interaction in Presence *v0.2*
 * XEP-0320: Use of DTLS-SRTP in Jingle Sessions *v0.2*
 * XEP-0333: Chat Markers *v0.2*
 * XEP-0334: Message Processing Hints *v0.1*
 * XEP-0338: Jingle Grouping Framework *v0.1*
 * XEP-0339: Source-Specific Media Attributes in Jingle *v0.1*


# XMPP Extensions (Updated)

 * XEP-0272: Multiparty Jingle (Muji) *v0.2*
   * Alternate URL: https://demo.frenchtouch.pro/valerian.saliou/xmpp/extensions/xep-0272.html
 * XEP-0313: Message Archive Management *v0.3*
   * Alternate URL: https://demo.frenchtouch.pro/valerian.saliou/xmpp/extensions/xep-0313.html


# XMPP Extensions (Proposed)
 * XEP-xxxx: Notification Inbox *v0.1*
   * Alternate URL: http://xmpp.org/extensions/inbox/notification-inbox.html


# Others

 * RFC-3264: An Offer/Answer Model with Session Description Protocol (SDP)
